/*
 * spoonacular API
 *
 * The spoonacular Nutrition, Recipe, and Food API allows you to access over thousands of recipes, thousands of ingredients, 800,000 food products, over 100,000 menu items, and restaurants. Our food ontology and semantic recipe search engine makes it possible to search for recipes using natural language queries, such as \"gluten free brownies without sugar\" or \"low fat vegan cupcakes.\" You can automatically calculate the nutritional information for any recipe, analyze recipe costs, visualize ingredient lists, find recipes for what's in your fridge, find recipes based on special diets, nutritional requirements, or favorite ingredients, classify recipes into types and cuisines, convert ingredient amounts, or even compute an entire meal plan. With our powerful API, you can create many kinds of food and especially nutrition apps.  Special diets/dietary requirements currently available include: vegan, vegetarian, pescetarian, gluten free, grain free, dairy free, high protein, whole 30, low sodium, low carb, Paleo, ketogenic, FODMAP, and Primal.
 *
 * The version of the OpenAPI document: 1.1
 * Contact: mail@spoonacular.com
 * Generated by: https://openapi-generator.tech
 */

/// GetAnalyzedRecipeInstructions200Response : 



#[derive(Clone, Debug, PartialEq, Serialize, Deserialize)]
pub struct GetAnalyzedRecipeInstructions200Response {
    #[serde(rename = "parsedInstructions")]
    pub parsed_instructions: Vec<crate::models::GetAnalyzedRecipeInstructions200ResponseParsedInstructionsInner>,
    #[serde(rename = "ingredients")]
    pub ingredients: Vec<crate::models::GetAnalyzedRecipeInstructions200ResponseIngredientsInner>,
    #[serde(rename = "equipment")]
    pub equipment: Vec<crate::models::GetAnalyzedRecipeInstructions200ResponseIngredientsInner>,
}

impl GetAnalyzedRecipeInstructions200Response {
    /// 
    pub fn new(parsed_instructions: Vec<crate::models::GetAnalyzedRecipeInstructions200ResponseParsedInstructionsInner>, ingredients: Vec<crate::models::GetAnalyzedRecipeInstructions200ResponseIngredientsInner>, equipment: Vec<crate::models::GetAnalyzedRecipeInstructions200ResponseIngredientsInner>) -> GetAnalyzedRecipeInstructions200Response {
        GetAnalyzedRecipeInstructions200Response {
            parsed_instructions,
            ingredients,
            equipment,
        }
    }
}


